#include "checkablecomboboxmodel.h"
#include <QStandardItem>


#include <QtDebug>

CheckableComboBoxModel::CheckableComboBoxModel(QObject *parent) : QStandardItemModel(parent) {
    connect(this, SIGNAL(itemChanged(QStandardItem *)), this, SLOT(onItemChanged(QStandardItem *)));
}

QStandardItem* CheckableComboBoxModel::addItem(const QString &i, bool checkable)
{
    setRowCount(rowCount() + 1);
    QStandardItem* item = new QStandardItem(i);
    if(checkable) {
        item->setFlags(Qt::ItemIsUserCheckable | Qt::ItemIsEnabled);
        item->setData(Qt::Checked, Qt::CheckStateRole);
    }
    setItem(rowCount() -1, 0, item);
    return item;
}

void CheckableComboBoxModel::onItemChanged(QStandardItem *it)
{
    qDebug() << __PRETTY_FUNCTION__ << it;
    emit itemChecked(it->text(), it->data(Qt::CheckStateRole).toBool());
}
